// Rekurze nahrazuje cyklus
// Alternativa: funkce constexpr - lze volat 
// i v dob pekladu a consteval - lze volat pouze
// v dob pekladu

#include <iostream>
#include <stdexcept>
using namespace std;

template<int N>
struct faktoril
{
	static_assert(N >= 0, "Parametr mimo meze");
	enum {vsledek = N*faktoril<N-1>::vsledek};
};

template<>
struct faktoril<0>
{
	enum {vsledek = 1};
};

template<int N>
constexpr int faktoril_v = faktoril<N>::vsledek;


consteval int faktoril_f(int n)
{
	if (n < 0) throw out_of_range("");
	int vsledek = 1;
	while (n > 1) vsledek *= n--;
	return vsledek;
}

int main()
{
	int m = 5; 
	cout << faktoril_f(m) << endl;
	cout << faktoril_v<5> << endl;
	int A[faktoril_v<5>] = {};
	int B[faktoril_f(5)]{};
}